//----------------------------------------------------------------------------------
//  abs.c : o
//  Copyright (c) 2005-2008  N099
//----------------------------------------------------------------------------------
#include <windows.h>

#include "filter.h"
#include "abs.h"

//΍
NOA void abs_diff(const PIXEL_YC * restrict ref,
                  const PIXEL_YC * restrict now,
                  short * restrict res, int w)
{
    int i;
    short df[5];
    
    //rt[ƍƂ
    for(i=0; i<w; ++i){
        //e̐΍̍ől߂ĕۑ
        df[0] = (short)abs(now->y  - ref->y );
        df[1] = (short)abs(now->cb - ref->cb);
        df[2] = (short)abs(now->cr - ref->cr);
        df[0] = df[0]>df[1] ? df[0] : df[1];
        df[0] = df[0]>df[2] ? df[0] : df[2];
        
        *res++ = df[0];
        now++;
        ref++;
    }
}

//΍ SSE
NOA void abs_diff_sse(const PIXEL_YC * restrict ref,
                      const PIXEL_YC * restrict now,
                      short * restrict res, int w)
{
    int i;
    p_m64c nwm,rfm;
    p_m64r rsm;
    __m64 m0,m1,m2,n0,n1,n2;
    
    nwm = (p_m64c)now;
    rfm = (p_m64c)ref;
    rsm = (p_m64r)res;
    
    //rt[ƍƂ
    for(i=0; i<w; i+=4){
        //e̐΍̍ől߂ĕۑ
        m0 = _mm_subs_pi16(*nwm++, *rfm++);
        m1 = _mm_subs_pi16(*nwm++, *rfm++);
        m2 = _mm_subs_pi16(*nwm++, *rfm++);
        
        //̐Βl
        n0 = _mm_subs_pi16(_mm_setzero_si64(), m0);
        n1 = _mm_subs_pi16(_mm_setzero_si64(), m1);
        n2 = _mm_subs_pi16(_mm_setzero_si64(), m2);
        m0 = _mm_max_pi16(m0, n0);
        m1 = _mm_max_pi16(m1, n1);
        m2 = _mm_max_pi16(m2, n2);
        
        //m0 ( Y1, Cr0, Cb0,  Y0)
        //m1 (Cb2,  Y2, Cr1, Cb1)
        //m2 (Cr3, Cb3,  Y3, Cr2)
        
        //vf̓ւ
        n0 = _mm_unpacklo_pi16(m0, m1);
        n1 = _mm_unpackhi_pi16(m1, m2);
        n2 = _mm_unpacklo_pi32(m2, m2);
        
        //n0 (Cr1, Cb0, Cb1,  Y0)
        //n1 (Cr3, Cb2, Cb3,  Y2)
        //n2 ( Y3, Cr2,  Y3, Cr2)
        
        m2 = _mm_unpackhi_pi16(n0, n1);
        m1 = _mm_unpacklo_pi16(n0, n1);
        m0 = _mm_unpackhi_pi16(m0, n2);
        
        //m0 ( Y3,  Y1, Cr2, Cr0)
        //m1 (Cb3, Cb1,  Y2,  Y0)
        //m2 (Cr3, Cr1, Cb2, Cb0)
        
        //őlo
        m2 = _mm_max_pi16(m2, m1);
        m2 = _mm_max_pi16(m2, m0);
        
        //m2 (d3, d1, d2, d0)
        
        //ёւĕۑ
        *rsm++ = _mm_shuffle_pi16(m2, 0xD8); //3,1,2,0:11011000
    }
}


//΍ SSE2
NOA void abs_diff_sse2(const PIXEL_YC * restrict ref,
                       const PIXEL_YC * restrict now,
                       short * restrict res, int w)
{
    int i;
    p_m128c nwx,rfx;
    p_m128r rsx;
    __m128i xm0,xm1,xm2,xn0,xn1,xn2;
    
    nwx = (p_m128c)now;
    rfx = (p_m128c)ref;
    rsx = (p_m128r)res;
    
    //rt[ƍƂ
    for(i=0; i<w; i+=8){
        //e̐΍̍ől߂ĕۑ
        xm0 = _mm_subs_epi16(_mm_load_si128(nwx++), _mm_load_si128(rfx++));
        xm1 = _mm_subs_epi16(_mm_load_si128(nwx++), _mm_load_si128(rfx++));
        xm2 = _mm_subs_epi16(_mm_load_si128(nwx++), _mm_load_si128(rfx++));
        
        //̐Βl
        xn0 = _mm_subs_epi16(_mm_setzero_si128(), xm0);
        xn1 = _mm_subs_epi16(_mm_setzero_si128(), xm1);
        xn2 = _mm_subs_epi16(_mm_setzero_si128(), xm2);
        xm0 = _mm_max_epi16(xm0, xn0);
        xm1 = _mm_max_epi16(xm1, xn1);
        xm2 = _mm_max_epi16(xm2, xn2);
        
        //xm0 (Cb2,  Y2, Cr1, Cb1,  Y1, Cr0, Cb0,  Y0)
        //xm1 ( Y5, Cr4, Cb4,  Y4, Cr3, Cb3,  Y3, Cr2)
        //xm2 (Cr7, Cb7,  Y7, Cr6, Cb6,  Y6, Cr5, Cb5)
        
        //vf̕ёւ
        xn0 = _mm_unpacklo_epi32(xm1, xm0);
        xn1 = _mm_unpackhi_epi32(xm2, xm1);
        
        //xn0 ( Y1, Cr0, Cr3, Cb3, Cb0,  Y0,  Y3, Cr2)
        //xn1 ( Y5, Cr4, Cr7, Cb7, Cb4,  Y4,  Y7, Cr6)
        
        xn0 = _mm_shuffle_epi32(xn0, 0x93); //2,1,0,3:10010011
        xn2 = _mm_srli_si128(xn1, 4);
        xn1 = _mm_shuffle_epi32(xn1, 0x93); //2,1,0,3
        
        //xn0 (Cr3, Cb3, Cb0,  Y0,  Y3, Cr2,  Y1, Cr0)
        //xn1 (Cr7, Cb7, Cb4,  Y4,  Y7, Cr6,  Y5, Cr4)
        //xn2 (  0,   0,  Y5, Cr4, Cr7, Cb7, Cb4,  Y4)
        
        xm2 = _mm_unpacklo_epi64(xm2, xn2);
        xm0 = _mm_unpackhi_epi64(xm0, xn0);
        xn0 = _mm_unpacklo_epi64(xn0, xn1);
        
        //xm0 (Cr3, Cb3, Cb0,  Y0, Cb2,  Y2, Cr1, Cb1)
        //xn0 ( Y7, Cr6,  Y5, Cr4,  Y3, Cr2,  Y1, Cr0)
        //xm2 (Cr7, Cb7, Cb4,  Y4, Cb6,  Y6, Cr5, Cb5)
        
        xn1 = _mm_unpackhi_epi16(xm0, xm2);
        xm0 = _mm_unpacklo_epi16(xm0, xm2);
        
        //xn1 (Cr7, Cr3, Cb7, Cb3, Cb4, Cb0,  Y4,  Y0)
        //xm0 (Cb6, Cb2,  Y6,  Y2, Cr5, Cr1, Cb5, Cb1)
        
        xm1 = _mm_unpackhi_epi16(xm0, xn1);
        xn1 = _mm_unpacklo_epi16(xn1, xm0);
        
        //xm1 (Cr7, Cb6, Cr3, Cb2, Cb7,  Y6, Cb3,  Y2)
        //xn1 (Cr5, Cb4, Cr1, Cb0, Cb5,  Y4, Cb1,  Y0)
        
        xn2 = _mm_unpackhi_epi32(xn1, xm1);
        xn1 = _mm_unpacklo_epi32(xn1, xm1);
        
        //xn2 (Cr7, Cb6, Cr5, Cb4, Cr3, Cb2, Cr1, Cb0)
        //xn1 (Cb7,  Y6, Cb5,  Y4, Cb3,  Y2, Cb1,  Y0);
        
        //őlo
        xn0 = _mm_max_epi16(xn0, xn2);
        xn0 = _mm_max_epi16(xn0, xn1);
        
        //xn0 (d7, d6, d5, d4, d3, d2, d1, d0)
        
        _mm_store_si128(rsx++, xn0);
    }
}

//΍ SSE2iACj
NOA void abs_diff_sse2u(const PIXEL_YC * restrict ref,
                        const PIXEL_YC * restrict now,
                        short * restrict res, int w)
{
    int i;
    p_m128c nwx,rfx;
    p_m128r rsx;
    __m128i xm0,xm1,xm2,xn0,xn1,xn2;
    
    nwx = (p_m128c)now;
    rfx = (p_m128c)ref;
    rsx = (p_m128r)res;
    
    //rt[ƍƂ
    for(i=0; i<w; i+=8){
        //e̐΍̍ől߂ĕۑ
        xm0 = _mm_subs_epi16(_mm_loadu_si128(nwx++), _mm_loadu_si128(rfx++));
        xm1 = _mm_subs_epi16(_mm_loadu_si128(nwx++), _mm_loadu_si128(rfx++));
        xm2 = _mm_subs_epi16(_mm_loadu_si128(nwx++), _mm_loadu_si128(rfx++));
        
        //̐Βl
        xn0 = _mm_subs_epi16(_mm_setzero_si128(), xm0);
        xn1 = _mm_subs_epi16(_mm_setzero_si128(), xm1);
        xn2 = _mm_subs_epi16(_mm_setzero_si128(), xm2);
        xm0 = _mm_max_epi16(xm0, xn0);
        xm1 = _mm_max_epi16(xm1, xn1);
        xm2 = _mm_max_epi16(xm2, xn2);
        
        //xm0 (Cb2,  Y2, Cr1, Cb1,  Y1, Cr0, Cb0,  Y0)
        //xm1 ( Y5, Cr4, Cb4,  Y4, Cr3, Cb3,  Y3, Cr2)
        //xm2 (Cr7, Cb7,  Y7, Cr6, Cb6,  Y6, Cr5, Cb5)
        
        //vf̕ёւ
        xn0 = _mm_unpacklo_epi32(xm1, xm0);
        xn1 = _mm_unpackhi_epi32(xm2, xm1);
        
        //xn0 ( Y1, Cr0, Cr3, Cb3, Cb0,  Y0,  Y3, Cr2)
        //xn1 ( Y5, Cr4, Cr7, Cb7, Cb4,  Y4,  Y7, Cr6)
        
        xn0 = _mm_shuffle_epi32(xn0, 0x93); //2,1,0,3:10010011
        xn2 = _mm_srli_si128(xn1, 4);
        xn1 = _mm_shuffle_epi32(xn1, 0x93); //2,1,0,3
        
        //xn0 (Cr3, Cb3, Cb0,  Y0,  Y3, Cr2,  Y1, Cr0)
        //xn1 (Cr7, Cb7, Cb4,  Y4,  Y7, Cr6,  Y5, Cr4)
        //xn2 (  0,   0,  Y5, Cr4, Cr7, Cb7, Cb4,  Y4)
        
        xm2 = _mm_unpacklo_epi64(xm2, xn2);
        xm0 = _mm_unpackhi_epi64(xm0, xn0);
        xn0 = _mm_unpacklo_epi64(xn0, xn1);
        
        //xm0 (Cr3, Cb3, Cb0,  Y0, Cb2,  Y2, Cr1, Cb1)
        //xn0 ( Y7, Cr6,  Y5, Cr4,  Y3, Cr2,  Y1, Cr0)
        //xm2 (Cr7, Cb7, Cb4,  Y4, Cb6,  Y6, Cr5, Cb5)
        
        xn1 = _mm_unpackhi_epi16(xm0, xm2);
        xm0 = _mm_unpacklo_epi16(xm0, xm2);
        
        //xn1 (Cr7, Cr3, Cb7, Cb3, Cb4, Cb0,  Y4,  Y0)
        //xm0 (Cb6, Cb2,  Y6,  Y2, Cr5, Cr1, Cb5, Cb1)
        
        xm1 = _mm_unpackhi_epi16(xm0, xn1);
        xn1 = _mm_unpacklo_epi16(xn1, xm0);
        
        //xm1 (Cr7, Cb6, Cr3, Cb2, Cb7,  Y6, Cb3,  Y2)
        //xn1 (Cr5, Cb4, Cr1, Cb0, Cb5,  Y4, Cb1,  Y0)
        
        xn2 = _mm_unpackhi_epi32(xn1, xm1);
        xn1 = _mm_unpacklo_epi32(xn1, xm1);
        
        //xn2 (Cr7, Cb6, Cr5, Cb4, Cr3, Cb2, Cr1, Cb0)
        //xn1 (Cb7,  Y6, Cb5,  Y4, Cb3,  Y2, Cb1,  Y0);
        
        //őlo
        xn0 = _mm_max_epi16(xn0, xn2);
        xn0 = _mm_max_epi16(xn0, xn1);
        
        //xn0 (d7, d6, d5, d4, d3, d2, d1, d0)
        
        _mm_store_si128(rsx++, xn0);
    }
}


